#include <windows.h>
/*

  This is an example on how you might remove and compress the imports section
  from a PE file in your executable packer. In this example I did not actually
  compress the API strings, that would be trivial from here, for clarity this just
  presents an example on how to restore the IAT by buildingit ourself and showing
  what data we need to accomplish it. 

  In review..the actual import table from the exe has been removed. One entry
  has been added to make the exe now dependant on this dll. When this dll loads,
  it manually loads the imports for the exe and places them at teh proper places.

  The exe running is now dependant on the logic in this dll where we could make
  a series of checks such as license checks, timeouts etc.

  This has been implemented as a dll for clarity sake and ease of development.
  If you wanted to make a tighter setup, you would embed all of this functionality
  into the target exe, or make a stub to drop this dll from an embedded resource
  and embed that in the exe or something. Many possibilities, all have been done,
  this is just a trainer so simplicity rules.

  Site:   http://sandsprite.com
  Author: dzzie@yahoo.com

*/

bool   Installed =false;
int    imgBase  = 0x400000;

int    dllCount  =1;
int    thunks[1] = {0x5000};
char*  dlls[1]   = {"kernel32.dll"};

char*  apis[1]   = {"GetACP,GetVersion,ExitProcess,TerminateProcess,GetCurrentProcess,"
				    "UnhandledExceptionFilter,GetModuleFileNameA,FreeEnvironmentStringsA,"
				    "FreeEnvironmentStringsW,WideCharToMultiByte,GetEnvironmentStrings,"
				    "GetEnvironmentStringsW,SetHandleCount,GetStdHandle,GetFileType,"
				    "GetStartupInfoA,HeapDestroy,HeapCreate,VirtualFree,HeapFree,"
				    "RtlUnwind,WriteFile,HeapAlloc,GetCPInfo,GetCommandLineA,GetOEMCP,"
				    "VirtualAlloc,HeapReAlloc,GetProcAddress,LoadLibraryA,GetLastError,"
				    "FlushFileBuffers,SetFilePointer,MultiByteToWideChar,LCMapStringA,"
				    "LCMapStringW,GetStringTypeA,GetStringTypeW,SetStdHandle,CloseHandle,"
				    "ReadConsoleInputA,SetConsoleMode,GetConsoleMode,CreateFileA,"
				    "WriteConsoleA,"
				   };



unsigned long EnableWrite(char* offset, int size){
	unsigned long prevPerm;
	if(!VirtualProtect(offset, size, PAGE_EXECUTE_READWRITE, &prevPerm)) return 0;
	return prevPerm;
}

int RestorePerm(char* offset, int size, unsigned long oldPerm){
	return VirtualProtect(offset, size, oldPerm, &oldPerm) ;
}

int CalcLen(char *apiStr){ //calc pointer table size by num 
	int i=0, ret=0;        //of elements in api name array
	while(apiStr[i] > 0){
		if(apiStr[i] == ',') ret++;
		i++;
	}
	return ret*4; //each fx pointer is 4 bytes
}


//use as few api as possible in your loading stub so it will be
//easier to migrate to a compiled in version if you decide to go
//that route.

void main(void){

	int* thunk;
	char *api;
	char tmp[80];
	HMODULE h=0;
	int v=0, j=0, x=0, thunkSz=0;
	unsigned long perm=0;


	for(int i=0;i<dllCount;i++){
		
		h = LoadLibrary(dlls[i]);
		api = apis[i];

		thunk = (int*)(thunks[i] + imgBase);
		thunkSz = CalcLen(api); 
		perm = EnableWrite( (char*)thunk, thunkSz );

		while(api[x] > 0){
			
			if(api[x] != ','){
				tmp[j++] = api[x++];  //copy each fx name to tmp buffer char by char
			}
			else{
			    x++; tmp[j]=0;
				v = (int)GetProcAddress(h,tmp);				
				*thunk = v;  //*thunk points to where pointer should live, addval to table
				thunk++;     //increment pointer 4 bytes to next address
				j=0;
				//MessageBox(0,tmp,"",0);
			}
		}

		RestorePerm( (char*)thunk, thunkSz, perm); 
	
	}
 


}



BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved){
    if(!Installed){ Installed=true; main();	}
	return TRUE;
}




/*

Here is how LordPE lists the import table for our sample exe

->Import Table
   1. ImageImportDescriptor:
    OriginalFirstThunk:  0x000054CC
    TimeDateStamp:       0x00000000  (GMT: Thu Jan 01 00:00:00 1970)
    ForwarderChain:      0x00000000
    Name:                0x00005834  ("KERNEL32.dll")
    FirstThunk:          0x00005000

    Ordinal/Hint API name
    ------------ ---------------------------------------
    0x00B9       "GetACP"
    0x0174       "GetVersion"
    0x007D       "ExitProcess"
    0x029E       "TerminateProcess"
    0x00F7       "GetCurrentProcess"
    0x02AD       "UnhandledExceptionFilter"
    0x0124       "GetModuleFileNameA"
    0x00B2       "FreeEnvironmentStringsA"
    0x00B3       "FreeEnvironmentStringsW"
    0x02D2       "WideCharToMultiByte"
    0x0106       "GetEnvironmentStrings"
    0x0108       "GetEnvironmentStringsW"
    0x026D       "SetHandleCount"
    0x0152       "GetStdHandle"
    0x0115       "GetFileType"
    0x0150       "GetStartupInfoA"
    0x019D       "HeapDestroy"
    0x019B       "HeapCreate"
    0x02BF       "VirtualFree"
    0x019F       "HeapFree"
    0x022F       "RtlUnwind"
    0x02DF       "WriteFile"
    0x0199       "HeapAlloc"
    0x00BF       "GetCPInfo"
    0x00CA       "GetCommandLineA"
    0x0131       "GetOEMCP"
    0x02BB       "VirtualAlloc"
    0x01A2       "HeapReAlloc"
    0x013E       "GetProcAddress"
    0x01C2       "LoadLibraryA"
    0x011A       "GetLastError"
    0x00AA       "FlushFileBuffers"
    0x026A       "SetFilePointer"
    0x01E4       "MultiByteToWideChar"
    0x01BF       "LCMapStringA"
    0x01C0       "LCMapStringW"
    0x0153       "GetStringTypeA"
    0x0156       "GetStringTypeW"
    0x027C       "SetStdHandle"
    0x001B       "CloseHandle"
    0x020D       "ReadConsoleInputA"
    0x0250       "SetConsoleMode"
    0x00EB       "GetConsoleMode"
    0x0034       "CreateFileA"
    0x02D4       "WriteConsoleA"



*/